<?= $this->extend('common/main_admin_view') ?>

<?= $this->section('content') ?>
<!--begin::Content-->
	<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
		<!--begin::Toolbar-->
		<div class="toolbar" id="kt_toolbar">
			<!--begin::Container-->
			<div id="kt_toolbar_container" class="container-fluid d-flex flex-stack">
				<!--begin::Page title-->
				<div data-kt-swapper="true" data-kt-swapper-mode="prepend" data-kt-swapper-parent="{default: '#kt_content_container', 'lg': '#kt_toolbar_container'}" class="page-title d-flex align-items-center flex-wrap me-3 mb-5 mb-lg-0">
					<!--begin::Title-->
					<h1 class="d-flex align-items-center text-dark fw-bolder my-1 fs-3"><?= @$title ?>
					<!--begin::Separator-->
					<span class="h-20px border-gray-200 border-start ms-3 mx-2"></span>
					<!--end::Separator-->
					<!--begin::Description-->
					<small class="text-muted fs-7 fw-bold my-1 ms-1"></small>
					<!--end::Description--></h1>
					<!--end::Title-->
				</div>
				<!--end::Page title-->
				<!--begin::Actions-->
				<div class="d-flex align-items-center py-1">
				</div>
				<!--end::Actions-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Toolbar-->
		<!--begin::Post-->
		<div class="post d-flex flex-column-fluid" id="kt_post">
			<!--begin::Container-->
			<div id="kt_content_container" class="container">
				<!--begin::Row-->
				<div class="row gy-5 g-xl-8">
					<div class="col-ml-12">
						<form action="" class="submit-search">
							<div class="card">
								<div class="card-body">
									<div class="row">
										<div class="form-group col-md-4">
											<label>Dari Tanggal <strong>Nota</strong></label>
											<input type="date" class="form-control" name="from_date_note">
										</div>
										<div class="form-group col-md-4">
											<label>Sampai Tanggal <strong>Nota</strong></label>
											<input type="date" class="form-control" name="to_date_note">
										</div>
									</div>
									<div class="row">
										<div class="form-group col-md-4">
											<label>Dari Tanggal <strong>Mulai</strong></label>
											<input type="date" class="form-control" name="from_date_start">
										</div>
										<div class="form-group col-md-4">
											<label>Sampai Tanggal <strong>Mulai</strong></label>
											<input type="date" class="form-control" name="to_date_start">
										</div>
									</div>
									<div class="row">
										<div class="form-group col-md-4 mt-4">
											<label>Nota Order</label>
											<input type="text" class="form-control" name="note">
										</div>

										<div class="form-group col-md-4 mt-4">
											<label>Batch Code/Batch Process</label>
											<input type="text" class="form-control" name="batch_code">
										</div>

										<div class="form-group col-md-4 mt-4">
											<label>SKU Barang</label>
											<input type="text" class="form-control" name="sku">
										</div>

										<div class="form-group col-md-4 mt-4">
											<label>Tukang</label>
											<input type="text" class="form-control" name="operator">
										</div>
										<div class="form-group col-md-4 mt-4">
											<label>Status Proses</label>
											<select data-control="select2" class="form-control" name="status">
												<option value="">-- Select --</option>
												<option value="Proses">Proses</option>
												<option value="Completed">Completed</option>
											</select>
										</div>
										<div class="form-group col-md-4 mt-4">
											<label>Status Nota</label>
											<select data-control="select2" class="form-control" name="status_note">
												<option value="">-- Select --</option>
												<option value="New">New</option>
												<option value="Proses">Proses</option>
												<option value="Completed">Completed</option>
												<option value="Deleted">Deleted</option>
											</select>
										</div>
									</div>
									<button type="submit" class="btn btn-primary mt-5 button-search">Search</button>
									<button type="button" class="btn btn-warning mx-3 mt-5" onclick="exportExcel()"><i class="fa fa-print"></i> Cetak Excel</button>
								</div>
							</div>
						</form>
					</div>
					<!--begin::Col-->
					<div class="col-ml-12">
						<!--begin::List Widget 5-->
						<div class="card mb-5">
							<div class="card-body pt-2">
								<table id="kt_datatable" class="table table-striped table-row-bordered gy-5 gs-7">
								    <thead>
								        <tr class="fw-bold fs-6 text-gray-800">
								            <th class="min-w-20px">No Nota</th>
								            <th class="min-w-100px">Batch</th>
								            <th class="min-w-100px">Batch Process</th>
								            <th class="min-w-100px">Kadar</th>
								            <th class="min-w-100px">SKU Code</th>
								            <th class="min-w-100px">SKU Nama</th>
                                            <th class="min-w-100px">Nama Proses</th>
								            <th class="min-w-100px">Status</th>
								            <th class="min-w-100px">Jumlah Awal</th>
								            <th class="min-w-100px">Jumlah Akhir</th>
								            <th class="min-w-100px">Berat Awal</th>
                                            <th class="min-w-100px">Berat Akhir</th>
                                            <th class="min-w-100px">Dimulai</th>
								            <th class="min-w-100px">Selesai</th>
								        </tr>
								    </thead>
								    <tbody>
								    	
								    </tbody>
								</table>
							</div>
							<!--end: Card Body-->
						</div>
						<!--end: List Widget 5-->
					</div>
					<!--end::Col-->
				</div>
				<!--end::Row-->
			</div>
			<!--end::Container-->
		</div>
		<!--end::Post-->
	</div>
	<!--end::Content-->
<?= $this->endSection() ?>

<?= $this->section('js') ?>
<script type="text/javascript">
$(document).ready(function(){
	"use strict";

	// Class definition
	var KTDatatablesServerSide = function () {
    // Shared variables
    var table;
    var dt;

    // Private functions
    var initDatatable = function () {
        dt = $("#kt_datatable").DataTable({
            responsive:false,
            // searchDelay: 500,
            processing: true,
            serverSide: false,
            ordering: false,
            select: {
                style: 'os',
                selector: 'td:first-child',
                className: 'row-selected'
            },
            ajax: {
                url: "<?= base_url() ?>/report/batch-item-task",
            },
            columns: [
                {data: 'note'},
                {data: 'batch_code'},
                {data: 'group_note'},
                {data: 'gold_content'},
                {data: 'item_sku'},
                {data: 'item_name'},
                {data: 'task_name'},
                {data: 'status'},
                {data: 'input_quantity'},
                {data: 'output_quantity'},
                {data: 'input_weight'},
                {data: 'output_weight'},
                {data: 'start_date'},
                {data: 'end_date'},
            ],
        });

        table = dt.$;

        // Re-init functions on every table re-draw -- more info: https://datatables.net/reference/event/draw
        dt.on('draw', function () {
            initToggleToolbar();
            toggleToolbars();
            KTMenu.createInstances();
        });
    }

    var handleSearchDatatable = function () {
        const filterSearch = document.querySelector('[data-kt-docs-table-filter="search"]');
        filterSearch.addEventListener('keyup', function (e) {
            dt.search(e.target.value).draw();
        });
    }

    // Init toggle toolbar
    var initToggleToolbar = function () {
        const container = document.querySelector('#kt_datatable');
        const checkboxes = container.querySelectorAll('[type="checkbox"]');

        // Toggle delete selected toolbar
        checkboxes.forEach(c => {
            // Checkbox on click event
            c.addEventListener('click', function () {
                setTimeout(function () {
                    toggleToolbars();
                }, 50);
            });
        });
    }

    // Toggle toolbars
    var toggleToolbars = function () {
        // Define variables
        const container = document.querySelector('#kt_datatable');
        const toolbarBase = document.querySelector('[data-kt-docs-table-toolbar="base"]');
        const toolbarSelected = document.querySelector('[data-kt-docs-table-toolbar="selected"]');
        const selectedCount = document.querySelector('[data-kt-docs-table-select="selected_count"]');

        var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
        var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
            return new bootstrap.Tooltip(tooltipTriggerEl)
        })

    }

	    // Public methods
	    return {
	        init: function () {
	            initDatatable();
	            handleSearchDatatable();
	            initToggleToolbar();
	        }
	    }
	}();

	// On document ready
	KTUtil.onDOMContentLoaded(function () {
	    KTDatatablesServerSide.init();
	});
});

$('.submit-search').submit(function(e){    
    e.preventDefault();

    var data = $(this).serialize();
    var btn = $('.button-search').html();

    var from_date_note = $('input[name="from_date_note"]').val();
    var to_date_note = $('input[name="to_date_note"]').val();
    var from_date_start = $('input[name="from_date_start"]').val();
	var to_date_start = $('input[name="to_date_start"]').val()

    if(from_date_note != '' && to_date_note == ''){
    	return alertToastr('error', 'Sampai Tanggal Nota harus diisi');
    }

    if(from_date_start != '' && to_date_start == ''){
    	return alertToastr('error', 'Form Sampai Tanggal Selesai harus diisi');
    }

    const delay = ms => new Promise(res => setTimeout(res, ms));

    const loadSearchStudent = async () => {
        $('.button-search').attr('data-kt-indicator', 'on');
        $('.button-search').attr('disabled', '');
        $('.button-search').html('<span class="indicator-progress">\
        Please wait... <span class="spinner-border spinner-border-sm align-middle ms-2"></span>\
        </span>');
        await delay(1000);

        $('#kt_datatable').DataTable().ajax.url("<?= base_url() ?>/report/batch-item-task?"+data).load();
        console.log(data);
        await delay(1000);

        $('.button-search').removeAttr('disabled', '');
        $('.button-search').removeAttr('data-kt-indicator');
        $('.button-search').html(btn);
    }

    loadSearchStudent()
    
  });

function exportExcel(){
	let data = $('.submit-search').serialize();

	window.open('<?= base_url() ?>/report/batch-item-task?export-excel=true&'+data, 'blank');
}

</script>
<?= $this->endSection() ?>